#include <gtk/gtk.h>
#include <string.h>
#include "readeasy.h"
#include "file.h"
#include "font.h"
#include "callback.h"

void do_scrolling(StructData *sd);

void do_scrolling(StructData *sd)
{
	sd->conf.adjust_num=gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(sd->mainwin->scwin));
	sd->conf.curr_position = sd->conf.adjust_num->value;
	sd->conf.curr_position+=sd->conf.scroll_speed;
	if(sd->conf.curr_position<=sd->conf.adjust_num->upper)
	{
		gtk_adjustment_set_value(GTK_ADJUSTMENT(sd->conf.adjust_num),sd->conf.curr_position);	
		gtk_scrolled_window_set_vadjustment(GTK_SCROLLED_WINDOW(sd->mainwin->scwin),sd->conf.adjust_num);
	}
	else
	{
		/*显示完毕，删除time指针，调用下一个文件并开始滚屏*/
		//gtk_timeout_remove(timer1);
		/**/
		if(sd->conf.auto_next_file)
		{
			gtk_timeout_remove(timer1);
			printf("dddddddddddddddd\n");
		}
		else
		{
			printf("文件已结束。\n");
		}
		
	}	
}

gboolean on_motion_notify_event(GtkWidget *widget,GdkEventMotion *event,gpointer data)
{
	int x,y;
	GdkModifierType state;
	gdk_window_get_pointer(event->window,&x,&y,&state);
	sd->conf.scroll_speed=y/10;
	return 0;

}

void cb_file_list_activate(GtkMenuItem* menuitem,gpointer data)
{
	g_print("filelist");
}

void cb_file_open_activate(GtkMenuItem* menuitem,gpointer data)
{
	GtkWidget *dialog;
//	FileInfo *fi;
	char *filename;
	dialog = gtk_file_chooser_dialog_new ("Open File",
				      NULL,
				      GTK_FILE_CHOOSER_ACTION_OPEN,
				      GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
				      GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				      NULL);
	gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER (dialog),g_path_get_dirname(sd->conf.filename));
	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
	{
		filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
		sd->conf.filename=filename;
		file_open_real(sd->mainwin->textview, filename);

	}
	
	gtk_widget_destroy (dialog);
  
}

void cb_file_quit(GtkWidget *widget,gpointer data)
{
//	if (!check_text_modification(sd))
		gtk_main_quit();
}

void cb_edit_prefererces_activate(GtkWidget *widget,gpointer data)
{
g_print("editcopy");
}

void cb_view_tool_activate(GtkWidget *widget,gpointer data)
{
	if(gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(widget)))
	{
		gtk_widget_show(sd->mainwin->toolbar);
	}else
	{
		gtk_widget_hide(sd->mainwin->toolbar);
	}
	
}



void cb_view_file_activate(GtkWidget *widget,gpointer type)
{
	static gboolean done=FALSE;
	if(done) { done=FALSE;return;}
	
	if(sd->conf.view_file_bar)
	{
		sd->conf.view_file_bar=FALSE;
		done=TRUE;
		gtk_paned_set_position(GTK_PANED(sd->mainwin->paned),0);
		if(type=="button")
			gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(m_folder),FALSE);
		if(type=="menu")
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_folder),FALSE);
	}else{
		sd->conf.view_file_bar=TRUE;
		done=TRUE;
		gtk_paned_set_position(GTK_PANED(sd->mainwin->paned),150);
		if(type=="button")
			gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(m_folder),TRUE);
		if(type=="menu")
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_folder),TRUE);
	}
}




void cb_view_scroll_activate(GtkWidget *widget, gpointer type)
{
	static gboolean done=FALSE;
	if(done) { done=FALSE; return; }
	
	if(sd->conf.auto_speed)
	{
		sd->conf.auto_speed=FALSE;
		done=TRUE;
		gtk_timeout_remove(timer1);
		if(type=="button")
			gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(m_start),FALSE);
		if(type=="menu")
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_start),FALSE);
	}else{
		sd->conf.auto_speed=TRUE;
		done=TRUE;
		timer1=gtk_timeout_add(150,(GtkFunction)do_scrolling,sd);
		if(type=="button")
			gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(m_start),TRUE);
		if(type=="menu")
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(b_start),TRUE);
	}
}

void cb_view_font_activate(GtkWidget *widget, gpointer data)
{

change_text_font_by_selector(sd->mainwin->textview);

}

void cb_view_font_set_size_activate(GtkWidget *widget, gpointer data)
{
/*char* buf;
gtk_label_get_text (widget->window)gtk_label_get(widget->window,buf);*/
g_print("%s",data);
//gtk_pango_font_description_set_size (PangoFontDescription *desc,
     //                                        gint size);

}

void cb_view_color_activate(GtkWidget *widget, gpointer type)
{
	GtkWidget *dialog;
	GtkColorSelection *colorsel;
	gint response;
	
	dialog=gtk_color_selection_dialog_new("选择颜色");
	gtk_window_set_transient_for(GTK_WINDOW(dialog),GTK_WINDOW(gtk_widget_get_toplevel(widget)));
	colorsel=GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(dialog)->colorsel);
	gtk_color_selection_set_has_opacity_control(colorsel,TRUE);
	gtk_color_selection_set_has_palette(colorsel,TRUE);
	gtk_signal_connect(GTK_OBJECT(dialog),"destroy",GTK_SIGNAL_FUNC(gtk_widget_destroy),&dialog);
	
	if(type=="base")
	{
		gtk_color_selection_set_previous_color(colorsel,&basecolor);
		gtk_color_selection_set_current_color(colorsel,&basecolor);
		
		
		if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK)
		{
			gtk_color_selection_get_current_color(colorsel,&basecolor);
			gtk_widget_modify_base(sd->mainwin->textview,GTK_STATE_NORMAL,&basecolor);
			
		}
	}else if(type=="text")
	{
		gtk_color_selection_set_previous_color(colorsel,&textcolor);
		gtk_color_selection_set_current_color(colorsel,&textcolor);
		
		
		if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK)
		{
			gtk_color_selection_get_current_color(colorsel,&textcolor);
			gtk_widget_modify_text(sd->mainwin->textview,GTK_STATE_NORMAL,&textcolor);
		}

	
	}
	gtk_widget_destroy(dialog);
}


void cb_help_about_activate(GtkWidget *widget,gpointer data)
{
	GtkWidget *dialog, *button,*box;
	gchar* title;
	GtkWidget *label;

	dialog = gtk_dialog_new();
	gtk_window_set_title(GTK_WINDOW(dialog), "关于ReadEasy 0.1");
	gtk_container_border_width(GTK_CONTAINER(dialog), 5);
	label = gtk_label_new(NULL);
	title="<span foreground=\"blue\"><big>ReadEasy 0.1</big></span>";
	gtk_label_set_markup(GTK_LABEL(label),title);
	gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);
	gtk_widget_show(label);
	
	label = gtk_label_new("ReadEasy--Linux下的ReadBook,支持自动滚屏，鼠标控制等功能。");
	gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);
	gtk_widget_show(label);
	
	label = gtk_label_new("作者：yetist(武校田)");
	gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);
	gtk_widget_show(label);
	
	label = gtk_label_new("主页：开源编程网 <http://www.osprg.org>");
	gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);
	gtk_widget_show(label);
	
	label = gtk_label_new("邮箱：yetist@osprg.org");
	gtk_label_set_justify(GTK_LABEL(label),GTK_JUSTIFY_CENTER);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), label, TRUE, TRUE, 0);
	gtk_widget_show(label);
	
	button = gtk_dialog_add_button(GTK_DIALOG(dialog),"Close",GTK_RESPONSE_ACCEPT);
	gtk_widget_show(button);
	gtk_widget_grab_focus(button);
	gtk_dialog_run (GTK_DIALOG (dialog));
	gtk_widget_destroy (dialog);
}


void on_toolbar_font_set_event(GtkFontButton *widget,gpointer data)
{
	char* fontname=gtk_font_button_get_font_name(widget);
set_text_font_by_name(sd->mainwin->textview,fontname);
}









