#ifndef __CFG_FILE_H__
#define __CFG_FILE_H__

#include <glib.h>
#include <time.h>

typedef struct{
	gchar *key;
	gchar *value;
}ConfigLine;

typedef struct{
	gchar *name;
	GList *lines;
}ConfigSection;

typedef struct{
	GList *sections;
	gchar *cfgfilename;
	gboolean changed;
}ConfigFile;

ConfigFile *cfg_file_new (void);
ConfigFile *cfg_file_open_file (gchar * filename);
gboolean    cfg_file_write_file (ConfigFile * cfg, gchar * filename);
void        cfg_file_free (ConfigFile * cfg);

gboolean cfg_file_read_string (ConfigFile * cfg, gchar * section,gchar * key, gchar ** value);
gboolean cfg_file_read_int (ConfigFile * cfg, gchar * section,gchar * key, gint * value);
gboolean cfg_file_read_long (ConfigFile * cfg, gchar * section,gchar * key, glong * value);
gboolean cfg_file_read_time (ConfigFile * cfg, gchar * section,gchar * key, time_t * value);
gboolean cfg_file_read_boolean (ConfigFile * cfg, gchar * section,gchar * key, gboolean * value);

void cfg_file_write_string (ConfigFile * cfg, gchar * section,gchar * key, gchar * value);
void cfg_file_write_int (ConfigFile * cfg, gchar * section, gchar * key,gint value);
void cfg_file_write_long (ConfigFile * cfg, gchar * section, gchar * key,glong value);
void cfg_file_write_time (ConfigFile * cfg, gchar * section,gchar * key, time_t value);
void cfg_file_write_boolean (ConfigFile * cfg, gchar * section,gchar * key, gboolean value);

void cfg_file_rename_section (ConfigFile * cfg, gchar * section,gchar * section_name);
void cfg_file_remove_key (ConfigFile * cfg, gchar * section,gchar * key);
void cfg_file_remove_section (ConfigFile * cfg, gchar * section);

#endif
