/*
 *  file.c
 *  This file is part of Leafpad
 *
 *  Copyright (C) 2004 Tarot Osuji
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include <sys/stat.h>
//#include "intl.h"
//#include "encoding.h"
//#include "dialog.h"
//#include "undo.h"
#include "file.h"
gint file_open_real(GtkWidget *textview, gchar *filename)
{
	FILE *fp;
	glong length,dlong;
	glong bytes_read;
	gchar *buf,*dbuf;
	GtkTextIter iter;
	GtkTextIter start,end;
	struct stat pstat;
	
	if(stat(filename,&pstat)==-1)
	{
		g_print("file error here...\n");
		return;
	}
	length =pstat.st_size;
	buf=g_malloc(length);
	
	
	GtkTextBuffer *textbuffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview));

//	gtk_text_buffer_set_text(textbuffer, "", 0);
	gtk_text_buffer_get_start_iter(textbuffer, &start);
	gtk_text_buffer_get_end_iter(textbuffer, &end);
	gtk_text_buffer_delete(textbuffer,&start,&end);
	gtk_text_buffer_get_iter_at_line_index(textbuffer,&iter,0,0);
	fp=fopen(filename,"r");
	if(fp==NULL)
	{
		g_print("error:file can't open.\n");
		g_free(buf);
		return;
	}
	
	bytes_read=fread(buf,sizeof(gchar),length,fp);
	if(g_utf8_validate(buf,bytes_read,NULL)==FALSE)
	{
		dbuf=g_locale_to_utf8(buf,length,NULL,&dlong,NULL);
		if(bytes_read==length)
		{
			gtk_text_buffer_insert(textbuffer,&iter,dbuf,dlong);
		}
	}
	else
	{
		if(bytes_read==length)
			gtk_text_buffer_insert(textbuffer,&iter,buf,length);
	}
	if(ferror(fp))
	{
		fclose(fp);
		g_free(buf);

	}
	return 0;

}

