#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include "menu.h"
#include "readeasy.h"
#include "callback.h"

GtkWidget *create_menu_bar(GtkWidget *window)
{
	GtkAccelGroup *accel_group;
	GtkWidget* menubar;
	GtkWidget* rootmenu;
	GtkWidget* submenu;
	GtkWidget* menu;
	GtkWidget* submenuitem;
	GtkWidget* menuitem;
	
	accel_group = gtk_accel_group_new();
	gtk_window_add_accel_group(GTK_WINDOW(window), accel_group);
	menubar=gtk_menu_bar_new();
	
	rootmenu=gtk_menu_item_new_with_mnemonic("文件(_F)");                  //文件菜单
	menu=gtk_menu_new();                                               
//	menuitem=gtk_menu_item_new_with_mnemonic("文件列表(_L)");              //文件列表
//	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
//	g_signal_connect(G_OBJECT(menuitem),"activate",
//			G_CALLBACK(cb_file_list_activate),NULL);
	menuitem=gtk_image_menu_item_new_from_stock(GTK_STOCK_OPEN,accel_group);//打开
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	g_signal_connect(G_OBJECT(menuitem),"activate",
			G_CALLBACK(cb_file_open_activate),NULL);
	menuitem=gtk_separator_menu_item_new();                                 //-----
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);		
	menuitem=gtk_image_menu_item_new_from_stock(GTK_STOCK_QUIT,accel_group);//退出
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	g_signal_connect(G_OBJECT(menuitem),"activate",
			G_CALLBACK(cb_file_quit),NULL);	
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(rootmenu),menu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menubar),rootmenu);
	
/*	rootmenu=gtk_menu_item_new_with_mnemonic("编辑(_E)");                   //编辑菜单
	menu=gtk_menu_new();                                                
	menuitem=gtk_menu_item_new_with_mnemonic("全选(_A)");                      //全选
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	gtk_widget_add_accelerator (menuitem, "activate", accel_group,
                              GDK_A, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);//-----
	menuitem=gtk_separator_menu_item_new();
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	
	menuitem=gtk_image_menu_item_new_from_stock(GTK_STOCK_FIND,accel_group);//查找
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	menuitem=gtk_menu_item_new_with_mnemonic("查找下一个(_C)");               //查找下一个
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	gtk_widget_add_accelerator (menuitem, "activate", accel_group,
                              GDK_F3, GDK_RELEASE_MASK, GTK_ACCEL_VISIBLE);
	
	menuitem=gtk_separator_menu_item_new();
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	
	menuitem=gtk_image_menu_item_new_from_stock(GTK_STOCK_PREFERENCES,accel_group);//首选项
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	g_signal_connect(G_OBJECT(menuitem),"activate",
			G_CALLBACK(cb_edit_prefererces_activate),sd);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(rootmenu),menu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menubar),rootmenu);*/
	
	rootmenu=gtk_menu_item_new_with_mnemonic("视图(_V)");                   //[视图菜单]
	menu=gtk_menu_new();         
	                                       
	menuitem=gtk_check_menu_item_new_with_label("工具");                     //工具
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	gtk_check_menu_item_set_active(GTK_CHECK_MENU_ITEM(menuitem),TRUE);
	g_signal_connect(G_OBJECT(menuitem),"toggled",
			G_CALLBACK(cb_view_tool_activate),NULL);
	gtk_widget_add_accelerator (menuitem, "activate", accel_group,
                              GDK_T, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
	m_folder=gtk_check_menu_item_new_with_label("文件");                     //文件
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),m_folder);
	g_signal_connect(G_OBJECT(m_folder),"toggled",
			G_CALLBACK(cb_view_file_activate),"menu");
				
	menuitem=gtk_separator_menu_item_new();
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	
	m_start=gtk_check_menu_item_new_with_label("卷动");                     //卷动
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),m_start);
	g_signal_connect(G_OBJECT(m_start),"toggled",
			G_CALLBACK(cb_view_scroll_activate),"menu");
	gtk_widget_add_accelerator (m_start, "activate", accel_group,
                              GDK_Return, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);
						
/*	menuitem=gtk_check_menu_item_new_with_label("速度");                     //速度
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);*/
	
	menuitem=gtk_menu_item_new_with_label("字体");                     //字体
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	
 	g_signal_connect(G_OBJECT(menuitem),"activate",G_CALLBACK(cb_view_font_activate),NULL);

	menuitem=gtk_menu_item_new_with_label("颜色");                     //字体
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);

	submenu=gtk_menu_new();
	submenuitem=gtk_menu_item_new_with_label("背景");
	gtk_menu_shell_append(GTK_MENU_SHELL(submenu),submenuitem);
	g_signal_connect(G_OBJECT(submenuitem),"activate",
			G_CALLBACK(cb_view_color_activate),"base");
	submenuitem=gtk_menu_item_new_with_label("文字");
	gtk_menu_shell_append(GTK_MENU_SHELL(submenu),submenuitem);
	g_signal_connect(G_OBJECT(submenuitem),"activate",
			G_CALLBACK(cb_view_color_activate),"text");
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menuitem),submenu);
	
/*	submenu=gtk_menu_new();
	gint i;
	for(i=1;i<10;i++)
	{
		static char retbuf[20];
		sprintf(retbuf,"%d", i);
		submenuitem=gtk_menu_item_new_with_label(retbuf);
		gtk_menu_shell_append(GTK_MENU_SHELL(submenu),submenuitem);
	g_signal_connect(G_OBJECT(menuitem),"activate",
			G_CALLBACK(cb_view_font_set_size_activate),i);
	}
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menuitem),submenu);
	*/
						
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(rootmenu),menu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menubar),rootmenu);
	
	rootmenu=gtk_menu_item_new_with_mnemonic("帮助(_H)");                   //[帮助菜单
	menu=gtk_menu_new();                                                
/*	menuitem=gtk_image_menu_item_new_from_stock(GTK_STOCK_HELP,accel_group);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);*/
//	g_signal_connect(G_OBJECT(menuitem),"activate",
//			G_CALLBACK(cb_help_about_activate),sd);
	menuitem=gtk_menu_item_new_with_mnemonic("关于(_A)...");                       //关于
	gtk_menu_shell_append(GTK_MENU_SHELL(menu),menuitem);
	g_signal_connect(G_OBJECT(menuitem),"activate",
			G_CALLBACK(cb_help_about_activate),NULL);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(rootmenu),menu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menubar),rootmenu);
	
	return menubar;
}

