/*
 *  leafpad.h
 *  This file is part of Leafpad
 *
 *  Copyright (C) 2004 Tarot Osuji
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _READEASY_H
#define _READEASY_H

/* autoconf */
#ifdef HAVE_CONFIG_H
#	include "config.h"
#endif

/* gettext */
#include "intl.h"

/* Shared Libraries */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

/* Original Functions */
#include "file.h"

#define _DEBUG
#ifdef _DEBUG

#define PACKAGE "readeasy"
#define PACKAGE_NAME "Readeasy"

#endif
//#define _DEBUG
/* Data Structure */
typedef struct {
	GtkWidget *window;
	GtkWidget *menubar;
	GtkWidget *toolbar;
	GtkWidget *paned;
	GtkWidget *folderview;
	GtkWidget *textview;
	GtkWidget *scwin;
	GtkTextBuffer *textbuffer;
} MainWindow;

typedef struct {
	MainWindow *mainwin;
//	FileInfo *fi;
	gchar *filepath;

	/* config file */
	struct {
		gint width;
		gint height;
		gint left;
		gint top;
		gchar *fontname;
		gchar *filename;
		gboolean wordwrap;
		gboolean linenumbers;
		gboolean autoindent;
		gchar *charset;
		gboolean auto_speed;//自动卷屏?
		gboolean view_file_bar;//显示文件夹？
		gboolean auto_next_file;//自动打开下一个文件?
		gdouble is_scroll;
		gchar* recent_file;
		
		GtkAdjustment* adjust_num;
		gdouble curr_position;//当前位置（行）
		gdouble scroll_speed;
		
		
	} conf;
} StructData;

	StructData *sd;
	GtkCheckMenuItem *m_folder;//由于从toolbar指针中我无法得到button的指针,
	GtkWidget *m_start;//从menubar指针中也无法得到menuitem的指针,
	GtkWidget *b_folder;//所以加上了m_,b_的全局指针.
	GtkWidget *b_start;//
	GtkWidget *b_font;
	static GdkColor basecolor={0,0xffff,0xffff,0xffff};
	static GdkColor textcolor={0,0,0,0};
static gint timer1;

#endif /* _READEASY_H */
