/* 
 * Copyright (c) 2001 by Yetist<yetist@osprg.org>  All Rights Reserved
 *  Distributed under the terms of the GNU General Public License (GPL)
 *  See the GNU Library General Public License for more details.
 */
 
 
#include <gtk/gtk.h>
#include "readeasy.h"
#include "window.h"
#include "menu.h"
#include "toolbar.h"
#include "callback.h"

static gboolean cb_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
	cb_file_quit(widget,data);//callback.c
	
	return TRUE;
}
MainWindow *create_main_window()
{  
	GtkWidget* window;
	GtkWidget* vbox;
	GtkWidget* menubar;
	GtkWidget* toolbar;
	GtkWidget* vpaned;
	GtkWidget* scrolled_window;
	GtkWidget* view;
	GtkTextBuffer* buffer;
	GtkTextIter start,end;
	GdkPixbuf *icon;

	MainWindow *mainwin = g_malloc(sizeof(MainWindow));
  
	window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	g_signal_connect(G_OBJECT(window),"delete_event",G_CALLBACK(cb_delete_event),NULL);
	
	gtk_window_set_title(GTK_WINDOW(window),PACKAGE_NAME);
	icon = gdk_pixbuf_new_from_file("./readeasy.png", NULL);
	gtk_window_set_icon(GTK_WINDOW(window), icon);

//	gtk_widget_set_usize(GTK_WINDOW(window),sd->conf.width,sd->conf.height);
//	gtk_widget_set_uposition(window,25,100);
	gtk_widget_set_uposition(window,sd->conf.left,sd->conf.top);
	
	gtk_window_set_default_size(GTK_WINDOW(window),sd->conf.width,sd->conf.height);
//	gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
//	gtk_widget_set_uposition(window,sd->conf.left,sd->conf.top);
	
	vbox=gtk_vbox_new(FALSE,0);
	gtk_container_add(GTK_CONTAINER(window),vbox);
	
	menubar=create_menu_bar(window);
	gtk_box_pack_start(GTK_BOX(vbox),menubar,FALSE,FALSE,0);
	
	toolbar=create_toolbar(window);
	gtk_box_pack_start(GTK_BOX(vbox),toolbar,FALSE,FALSE,0);
	
	vpaned = gtk_hpaned_new ();
	gtk_box_pack_start(GTK_BOX(vbox),vpaned,TRUE,TRUE,0);
	
	/**************************左边的容格**************************/	
	GtkWidget *frame1 = gtk_frame_new (NULL);
	gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_IN);
	gtk_paned_pack1 (GTK_PANED (vpaned), frame1, FALSE, FALSE);
	
	/**************************左边的容格**************************/	
	
	
	
	view=gtk_text_view_new();	
	buffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(view));
	gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(view),GTK_WRAP_CHAR);
	g_signal_connect(GTK_OBJECT(view),"motion-notify-event",
  			G_CALLBACK(on_motion_notify_event),NULL);
	
	scrolled_window=gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
	 						GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);
	gtk_widget_set_size_request (scrolled_window,250,-1); 
	gtk_container_add (GTK_CONTAINER (scrolled_window), view);	

	gtk_paned_pack2 (GTK_PANED (vpaned), scrolled_window,TRUE,FALSE);
	
	
	mainwin->window = window;
	mainwin->menubar=menubar;
	mainwin->toolbar=toolbar;
	mainwin->paned=vpaned;
	mainwin->scwin=scrolled_window;
	mainwin->folderview=frame1;
	mainwin->textview=view;
	mainwin->textbuffer=buffer;
	
	return mainwin;
}

gchar *get_current_file_basename(gchar *filename)
{
	gchar *basename;
	
	if (filename)
		basename = g_path_get_basename(g_filename_to_utf8(filename, -1, NULL, NULL, NULL));
	else
		basename = g_strdup("Untitled");
	
	return basename;
}


void set_main_window_title()
{
	gchar *basename, *title;
	
	basename = get_current_file_basename(sd->conf.filename);
	if (sd->conf.filename) {
		if (g_file_test(g_filename_to_utf8(sd->conf.filename, -1, NULL, NULL, NULL),
			G_FILE_TEST_EXISTS))
			title = g_strdup(basename);
		else
			title = g_strdup_printf("%s", basename);
	} else
		title = g_strdup_printf("%s", basename);
//		title = g_strdup(basename);
//		title = g_strdup_printf(PACKAGE_NAME);
	title = g_strdup_printf("%s--ReadEasy 0.1", title);
	gtk_window_set_title(GTK_WINDOW(sd->mainwin->window), title);
	g_free(title);
	g_free(basename);
}
